function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from "react";

function loadAndInitGAPI() {
  return new Promise(function (resolve, reject) {
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.src = "https://apis.google.com/js/api.js";
    script.onload = function (e) {
      window.gapi.load("auth2", function () {
        resolve(window.gapi);
      });
    };
    document.getElementsByTagName("head")[0].appendChild(script);
  });
}

var GapiAuth = {};

export var GoogleLogout = function GoogleLogout() {
  window.gapi.auth2.getAuthInstance().signOut();
};

var GoogleAuth = function (_React$Component) {
  _inherits(GoogleAuth, _React$Component);

  function GoogleAuth() {
    var _temp, _this, _ret;

    _classCallCheck(this, GoogleAuth);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.clickHandler = function () {
      if (GapiAuth.isSignedIn && GapiAuth.isSignedIn.get()) {
        var user = GapiAuth.currentUser.get();
        var profile = user.getBasicProfile();
        var output = {
          profile: {
            id: profile.getId(),
            firstName: profile.getGivenName(),
            lastName: profile.getFamilyName(),
            email: profile.getEmail(),
            image: profile.getImageUrl()
          }
        };
        _this.props.onSuccess(output);
      } else {
        GapiAuth.signIn().then(function (user) {
          var profile = user.getBasicProfile();
          var output = {
            profile: {
              id: profile.getId(),
              firstName: profile.getGivenName(),
              lastName: profile.getFamilyName(),
              email: profile.getEmail()
            }
          };
          _this.props.onSuccess(output);
        });
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  GoogleAuth.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    loadAndInitGAPI().then(function (gapi) {
      gapi.auth2.init({ client_id: _this2.props.appId }).then(function () {
        GapiAuth = window.gapi.auth2.getAuthInstance();
      });
    });
  };

  GoogleAuth.prototype.render = function render() {
    var Component = this.props.component;

    return React.createElement(Component, { onClick: this.clickHandler });
  };

  return GoogleAuth;
}(React.Component);

export default GoogleAuth;